using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.IO;
using System.Data.SqlClient;

namespace Trust
{
    public partial class Admin : Form
    {
        Trust rust = new Trust();
        Normal_File nfile = new Normal_File();
        ReadOnly ronly = new ReadOnly();
        FileReadOnly fread = new FileReadOnly();
        Encrypt en = new Encrypt();
        FileEncrypt fen = new FileEncrypt();
        FileNormal fnor = new FileNormal();
        Decrypt dec = new Decrypt();
        IPEndPoint ipEnd;
        Socket sock;
        SqlConn sq = new SqlConn();
        SqlCommand cmd,cmd1,cmd2;
        SqlDataReader dr;

        string receivedPath = "C:\\Recieve", fileini, fileName, fpath;
        public Admin()
        {
            InitializeComponent();
        }

        private void Admin_Load(object sender, EventArgs e)
        {
            
            lblError.Text = "";
            txtUname.Text = "";
            txtPass.Text = "";
            groupBox1.Visible = false;
            viewToolStripMenuItem.Visible = false ;
            trustworthyToolStripMenuItem.Visible = false;
            sendToolStripMenuItem.Visible = false;
            DirectoryInfo di = new DirectoryInfo("C:\\Recieve");
            if (di.Exists)
            {
                backgroundWorker1.RunWorkerAsync();
            }
            else
            {
                di.Create();
                backgroundWorker1.RunWorkerAsync();
            }


            
        }

      

        private void btnQuit_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void txtUname_TextChanged(object sender, EventArgs e)
        {
            lblError.Text = "";
            txtPass.Text = "";
        }
        public void gbox()
        {
            groupBox1.Visible = false;
            trustworthyToolStripMenuItem.Visible = true;
            sendToolStripMenuItem.Visible = true;
            viewToolStripMenuItem.Visible = true;
        }

        private void adminToolStripMenuItem_Click(object sender, EventArgs e)
        {
            groupBox1.Visible = true;
        }

        private void btnLogin_Click_1(object sender, EventArgs e)
        {
            if (txtPass.Text == "" || txtUname.Text == "")
            {
                lblError.Text = "";
                lblError.Text = "Password or User Name cannot be null";
            }
            else
            {
                if (txtPass.Text == "a" && txtUname.Text == "a")
                {
                    lblMess.Text = "Ready to use the tool";

                    gbox();
                }
                else
                {
                    lblError.Text = "";
                    lblError.Text = "User Name or Password error try again";
                }
            }
        }

        private void setTrustedSystemToolStripMenuItem_Click(object sender, EventArgs e)
        {
            rust.ShowDialog();
        }

        private void btnQuit_Click_1(object sender, EventArgs e)
        {
            this.Close();
        }

        private void normalFileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            nfile.ShowDialog();
        }

        private void secreteFileToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void sendAsReadOnlyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ronly.ShowDialog();
        }

        private void normalFileToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            fnor.ShowDialog();
        }

        private void readOnlyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fread.ShowDialog();
        }
        public void Receive()
        {
            
            ipEnd = new IPEndPoint(IPAddress.Any, 5656);
            sock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.IP);
            sock.Bind(ipEnd);
            
            while (true)
            {
                try
                {
                    fileini = "";
                    //curMsg = "Starting...";
                    sock.Listen(100);

                    //curMsg = "Running and waiting to receive file.";
                    Socket clientSock = sock.Accept();

                    byte[] clientData = new byte[1024 * 5000];

                    int receivedBytesLen = clientSock.Receive(clientData);
                    //curMsg = "Receiving data...";

                    int fileNameLen = BitConverter.ToInt32(clientData, 0);
                   fileName = Encoding.ASCII.GetString(clientData, 4, fileNameLen);
                   sq.open();
                   cmd = new SqlCommand("select * from valid",sq.cn);
                   dr = cmd.ExecuteReader();
                   while (dr.Read())
                   {
                       if (dr.HasRows)
                       {
                           fileini = dr[0].ToString();
                       }
                   }
                   if (fileini == "" || fileName != fileini)
                   {

                       receivedPath = "";
                       db();
                   }
                   else
                   {
                       receivedPath = "C:\\Recieve";
                       db();
                   }
                   dr.Close();
                   sq.close();
                   if (fileName.Contains("&"))
                   {
                       encry();
                       
                   }

            

                    BinaryWriter bWrite = new BinaryWriter(File.Open(receivedPath + "/" + fileName, FileMode.Append)); ;
                    bWrite.Write(clientData, 4 + fileNameLen, receivedBytesLen - 4 - fileNameLen);

                  //lblMess.Text = "Saving file...";

                    bWrite.Close();
                    clientSock.Close();
                    
                    //curMsg = "Reeived & Saved file; Server Stopped.";
                }
                catch (Exception ex)
                {
                //    curMsg = "File Receving error.";
                }
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            
        }

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            Receive();
        }

        private void encryptToolStripMenuItem_Click(object sender, EventArgs e)
        {
            en.ShowDialog();
        }

        private void seToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fen.ShowDialog();
        }

       
        public void db()
    {
        sq.open();
        cmd1 = new SqlCommand("delete valid", sq.cn);
        cmd1.ExecuteNonQuery();
        sq.close();
    }

        private void fileReceivedToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dec.ShowDialog();
        }
        public void encry()
        {
            string col="\\";
            fpath=receivedPath+col+fileini;
            sq.open();
            cmd2 = new SqlCommand("insert into recEn values (@fpath,@fname)", sq.cn);
            cmd2.Parameters.Add(new SqlParameter("@fpath", SqlDbType.VarChar));            
            cmd2.Parameters.Add(new SqlParameter("@fname", SqlDbType.VarChar));
            cmd2.Parameters["@fname"].Value = fileini;
            cmd2.Parameters["@fpath"].Value = fpath;
            cmd2.ExecuteNonQuery();
            sq.close();

        }
        

    }
}