using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Net.Sockets;
using System.Net;
using System.IO;
using System.Security.Cryptography;

namespace Trust
{
    public partial class Encrypt : Form
    {
        SqlConn sq = new SqlConn();
        SqlCommand cmd;
        SqlCommand cmd1,cmd2,cmd3,cmd4;
        SqlDataReader dr;
        int i = 0;
        string ser1, exe,fileN;
        string fileDes, cryptFile, password, fileIni,fileDir,path1;
        public Encrypt()
        {
            InitializeComponent();
        }

        private void Encrypt_Load(object sender, EventArgs e)
        {
            btnEncrypt.Enabled = false;
            txtKey.Enabled = false;
            btnSend.Enabled = false;
            listBox1.Items.Clear();
            sq.open();
            cmd = new SqlCommand("select * from IP", sq.cn);
            dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                if (dr.HasRows)
                {
                    listBox1.Items.Add(dr[0].ToString());
                }
            }
            dr.Close();
            sq.close();
            listBox1.SelectedIndex = 0;
        }

        private void btnOpen_Click(object sender, EventArgs e)
        {
            lblError.Text = "";
            txtKey.Text = "";
            txtFileName.Text = "";
            openFileDialog1.ShowDialog();
            
            fileDes = openFileDialog1.FileName;
            if (fileDes == "openFileDialog1")
            {
                lblError.Text = "";
                lblError.Text = "Select a File first";
                txtFileName.Text = "";
            }
            else
            {
                txtFileName.Text = openFileDialog1.FileName;
                exe = fileDes.Substring(fileDes.IndexOf("."), 4);
                exe = exe.Substring(1, 3);
                fileIni = fileDes.Substring(fileDes.IndexOf("\\") + 1, fileDes.IndexOf(".") - 3);
                fileN = fileDes.Substring(fileDes.IndexOf("\\") + 1);
                fileDir = fileDes.Substring(0, fileDes.IndexOf("\\") + 1);
                if (exe == "DOC" || exe == "txt"||exe=="doc")
                {
                    txtKey.Enabled = true;
                }
                else
                {
                    lblError.Text = "";
                    lblError.Text = "Choose *.doc or *.txt file only";
                }
            }
        }

        private void btnSend_Click(object sender, EventArgs e)
        {

            if (listBox1.SelectedItem.ToString() == "")
            {
                lblError.Text = "";
                lblError.Text = "Select IP from List";
            }
            else
            {
                ser1 = listBox1.SelectedItem.ToString();
               
                send();
                
                //FileInfo fi = new FileInfo(cryptFile);
                //if (fi.Exists)
                //{
                //    fi.Delete();
                //}
            }
        }
        public void send()
        {
            try
            {
                IPAddress[] ipAddress = Dns.GetHostAddresses(ser1);
                IPEndPoint ipEnd = new IPEndPoint(ipAddress[0], 5656);
                Socket clientSock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.IP);


                string filePath = "";

                fileDes = cryptFile;
                fileDes = fileDes.Replace("\\", "/");
                while (fileDes.IndexOf("/") > -1)
                {
                    filePath += fileDes.Substring(0, fileDes.IndexOf("/") + 1);
                    fileDes = fileDes.Substring(fileDes.IndexOf("/") + 1);
                }


                byte[] fileNameByte = Encoding.ASCII.GetBytes(fileDes);

                lblError.Text = "";
                lblError.Text = "Buffering ...";
                byte[] fileData = File.ReadAllBytes(filePath + fileDes);
                byte[] clientData = new byte[4 + fileNameByte.Length + fileData.Length];
                byte[] fileNameLen = BitConverter.GetBytes(fileNameByte.Length);

                fileNameLen.CopyTo(clientData, 0);
                fileNameByte.CopyTo(clientData, 4);
                fileData.CopyTo(clientData, 4 + fileNameByte.Length);

                lblError.Text = "";
                lblError.Text = "Connection to server ...";
                clientSock.Connect(ipEnd);

                lblError.Text = "";
                lblError.Text = "File sending...";
                clientSock.Send(clientData);

                lblError.Text = "";
                lblError.Text = "Disconnecting...";
                clientSock.Close();

                lblError.Text = "";
                lblError.Text = "File transferred.";



            }

            catch (Exception ex)
            {
                if (ex.Message == "A connection attempt failed because the connected party did not properly respond after a period of time, or established connection failed because connected host has failed to respond")
                {
                    lblError.Text = "";
                    lblError.Text = "No Such System Available Try other IP";
                }
                else
                {
                    if (ex.Message == "No connection could be made because the target machine actively refused it")
                    {
                        lblError.Text = "";
                        lblError.Text = "File Sending fail. Because server not running.";
                    }
                    else
                    {
                        lblError.Text = "";
                        lblError.Text = "File Sending fail." + ex.Message;
                    }
                }
            }
        }

        private void btnEncrypt_Click(object sender, EventArgs e)
        {
           fileen();
           En();

           db();
        }
        public void En()
        {
            try
            {
                password = txtKey.Text; // Your Key Here
                UnicodeEncoding UE = new UnicodeEncoding();
                byte[] key = UE.GetBytes(password);
                //extend = fileName.Substring(fileName.IndexOf(".") + 1);

                cryptFile = "" + fileDir + "" + "" + fileIni + "&en" + i.ToString() + "." + exe + "";
                txtFile.Text = "" + fileIni + "&en" + i.ToString() + "." + exe + "";
                    
                FileStream fsCrypt = new FileStream(cryptFile, FileMode.Create);

                RijndaelManaged RMCrypto = new RijndaelManaged();
                //ICryptoTransform rijndaelTransform = null;

                //old//CryptoStream cs = new CryptoStream(fsCrypt,RMCrypto.CreateEncryptor(key,key), CryptoStreamMode.Write);
                CryptoStream cs = new CryptoStream(fsCrypt, RMCrypto.CreateEncryptor(key,key), CryptoStreamMode.Write);
                string inputFile = fileDes;


                FileStream fsIn = new FileStream(inputFile, FileMode.Open);

                int data;
                while ((data = fsIn.ReadByte()) != -1)
                    cs.WriteByte((byte)data);


                fsIn.Close();
                cs.Close();
                fsCrypt.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show("" + ex + "");
            }
            btnEncrypt.Enabled = false;
            txtKey.Enabled = false;
            btnSend.Enabled = true;
        }
        public void db()
        {
           
            sq.close();
            sq.open();
            cmd1 = new SqlCommand("insert into enkey values(@fileN,@keys,@dfileN)", sq.cn);
            cmd1.Parameters.Add(new SqlParameter("@fileN", SqlDbType.VarChar));
            cmd1.Parameters.Add(new SqlParameter("@keys", SqlDbType.VarChar));
            cmd1.Parameters.Add(new SqlParameter("@dfileN", SqlDbType.VarChar));
            string olynwname = "" + fileIni + "&en" + i.ToString() + "." + exe + "";
            FileInfo file=new FileInfo(olynwname);

            string dfil = file.Name;
            //old//cmd1.Parameters["@fileN"].Value = "" + fileIni + "&en" + i.ToString() + "." + exe + "";
            cmd1.Parameters["@fileN"].Value = "" + fileIni + "&en" + i.ToString() + "." + exe + "";

            cmd1.Parameters["@keys"].Value = password;
            cmd1.Parameters["@dfileN"].Value = dfil;
            cmd1.ExecuteNonQuery();
            sq.close();
            sq.open();
            string ppo="" + fileIni + "&en" + i.ToString() + "." + exe + "";
            cmd2 = new SqlCommand("insert into encrypt values(@fileP,@fileN)", sq.cn);
            FileInfo filee = new FileInfo(ppo);

            string dfik = filee.Name;
            cmd2.Parameters.Add(new SqlParameter("@fileP", SqlDbType.VarChar));
            cmd2.Parameters.Add(new SqlParameter("@fileN", SqlDbType.VarChar));
            
            cmd2.Parameters["@fileP"].Value = fileDes;
            cmd2.Parameters["@fileN"].Value = dfik;
           
            cmd2.ExecuteNonQuery();
            sq.close();
            sq.open();
            cmd3 = new SqlCommand("insert into valid values(@fname)", sq.cn);
            cmd3.Parameters.Add(new SqlParameter("@fname", SqlDbType.VarChar));
            cmd3.Parameters["@fname"].Value = "" + fileIni + "&en" + i.ToString() + "." + exe + "";
            cmd3.ExecuteNonQuery();
            sq.close();
        }
        private void txtKey_TextChanged(object sender, EventArgs e)
        {
            btnEncrypt.Enabled = true;
        }
        public void fileen()
        {
            //path1 = "" + fileIni + "&en" + i.ToString() + "." + exe + "";
            sq.open();
            cmd4 = new SqlCommand("select * from enkey", sq.cn);
            dr = cmd4.ExecuteReader();
            while (dr.Read())
            {
                if (dr.HasRows)
                {
                    string ss = dr[0].ToString();
                    if (ss == "" + fileIni + "&en" + i.ToString() + "." + exe + "")
                    {
                        i = i + 1;
                    }
                }
            }
        }
    }
}